#pragma  ot(6,SIZE)
#include <reg52.h>
#include <intrins.h>
#define  ERRORCOUNT 10
sbit     SDA=P0^0;
sbit     SCL=P0^1;
enum  eepromtype  {M2401,M2402,M2404,M2408,M2416,M2432,M2464,M24128,M24256};
enum  eepromtype EepromType;



//DataBuffΪд룯ַ
//ByteQuantity ΪҪдݵֽ
//Address ΪEEPROMƬڵַ
//ControlByte ΪEEPROMĿֽڣʽΪ(1)(0)(1)(0)(A2)(A1)(A0)(R/W),R/W=1,
//ʾ,R/W=0Ϊд,A2,A1,A0ΪEEPROMҳѡƬѡַ;
//EepromTypeΪöٱ,ΪM2401M24256еһ,ֱӦ24C0124C256;
//ֵΪһλ1ʾ˴βʧЧ0ʾɹ;
//ERRORCOUNTΪERRORCOUNTβʧЧֹ1
//SDASCLûԶ壬ݶΪP0^0P0^1;
//ûùܣֻҪֻӳĳвͿ;


/***********************************************************************************/
bit   RW24XX(unsigned char *DataBuff,unsigned char ByteQuantity,unsigned int Address,
                     unsigned char ControlByte,enum eepromtype EepromType)
{
void Delay(unsigned char DelayCount);
void IICStart(void);
void IICStop(void);
bit  IICRecAck(void);
void IICNoAck(void);
void IICAck(void);
unsigned char IICReceiveByte(void);
void IICSendByte(unsigned char sendbyte);
unsigned char data j,i=ERRORCOUNT;
bit      errorflag=1;
while(i--)
   {
   IICStart();
   IICSendByte(ControlByte&0xfe);
   if(IICRecAck())
       continue;
   if(EepromType>M2416)
      {
      IICSendByte((unsigned char)(Address>>8));
      if(IICRecAck())
         continue;
      }
   IICSendByte((unsigned char)Address);
   if(IICRecAck())
       continue;
   if(!(ControlByte&0x01))
      {
      j=ByteQuantity;
      errorflag=0;                      //********clr errorflag
      while(j--)
        {
        IICSendByte(*DataBuff++);
        if(!IICRecAck())
           continue;
        errorflag=1;
        break;
        }
      if(errorflag==1)
        continue;
      break;
      }
   else
     {
     IICStart();
     IICSendByte(ControlByte);
     if(IICRecAck())
       continue;
     while(--ByteQuantity)
       {
       *DataBuff++=IICReceiveByte();
       IICAck();
       }
     *DataBuff=IICReceiveByte();        //read last byte data
     IICNoAck();
     errorflag=0;
     break;
     }
  }
IICStop();
if(!(ControlByte&0x01))
  {
  Delay(255);
  Delay(255);
  Delay(255);
  Delay(255);
  }
return(errorflag);
}


/*****************ǶIICߵĲӳ***/
/***************************************/
void IICStart(void)
{
SCL=0;                  //
SDA=1;
SCL=1;
_nop_();
_nop_();
_nop_();
SDA=0;
_nop_();
_nop_();
_nop_();
_nop_();
SCL=0;
SDA=1;                  //
}

/*****************ֹͣIIC****************/
void IICStop(void)
{
SCL=0;
SDA=0;
SCL=1;
_nop_();
_nop_();
_nop_();
SDA=1;
_nop_();
_nop_();
_nop_();
SCL=0;
}

/**************Ӧλ*******************/
bit IICRecAck(void)
{
SCL=0;
SDA=1;
SCL=1;
_nop_();
_nop_();
_nop_();
_nop_();
CY=SDA;                 //ΪֵǷCYе
SCL=0;
return(CY);
}

/***************IIC߲Ӧ*******************/
void IICACK(void)
{
SDA=0;
SCL=1;
_nop_();
_nop_();
_nop_();
_nop_();
SCL=0;
_nop_();
SDA=1;
}

/*****************IIC߲Ӧ***************/
void IICNoAck(void)
{
SDA=1;
SCL=1;
_nop_();
_nop_();
_nop_();
_nop_();
SCL=0;
}

/*******************IICд*********************/
void IICSendByte(unsigned char sendbyte)
{
unsigned char data j=8;
for(;j>0;j--)
   {
   SCL=0;
   sendbyte<<=1;        //C51ʵʼջʹCY=sendbyte^7;
   SDA=CY;
   SCL=1;
   }
SCL=0;
}

/**********************IIC϶ӳ**********/
unsigned char IICReceiveByte(void)
{
register receivebyte,i=8;
SCL=0;
while(i--)
   {
   SCL=1;
   receivebyte=(receivebyte<<1)|SDA;
   SCL=0;
   }
return(receivebyte);
}

/***************һʱ************************/
void Delay(unsigned char DelayCount)
{
while(DelayCount--);
}

